# typeface.py
# By Chris Proctor and Stacy S

# Contains one function for each letter in the English alphabet. 
# Each function should draw its letter at a scale of `unit`, and then 
# return back to the same position and heading where it started. 

# Note: The `sqrt` function from math may be helpful--if you want to 
# move the turtle along the diagonal of a square with side length x, 
# the turtle should move a distance of sqrt(x)

from turtle import *
from math import sqrt

def draw_master_ghostyskirt(unit, length):
    for width in range(length):
        circle(-unit/4, 180)
        circle(unit/4, 180)
    circle(-unit/4, 180)

def draw_segment(turn1, d1, rad1, deg1, turn2, d2, rad2, deg2, turn3, d3):
    right(turn1)
    forward(d1)
    circle(rad1, deg1)
    right(turn2)
    forward(d2)
    circle(rad2, deg2)
    right(turn3)
    forward(d3)

def draw_eye(unit):
    right(45)
    fillcolor('black')
    begin_fill()
    draw_segment(0,0,unit/2,90, 0,0,unit/12,90,0,0)
    draw_segment(0,0,unit/2,90, 0,0,unit/12,90,0,0)
    end_fill()
    left(45)
    
def fly_turn(dega, da, degb, db, degc):
    penup()
    right(dega)
    forward(da)
    right(degb)
    forward(db)
    right(degc)
    pendown()

def draw_letter_a(unit):
    width(1)
# outline of A
    fly_turn(0,unit,270,unit/4,0) #(1,1/4)
    draw_segment(0, 19*unit/4,-3*unit,180,0,19*unit/4,0,0,0,0) #(7,1/4)
    draw_master_ghostyskirt(unit,2) #(9/2,1/4)
    draw_segment(0,2*unit,unit/2,180,0,2*unit,0,0,0,0) #(7/2,1/4)
    draw_master_ghostyskirt(unit,2) #(1,1/4)
# face of A
    fly_turn(0,15*unit/4,90,3*unit,0)
    circle(unit, 450) #(5,5)
    fly_turn(0,5*unit/4,0,0,0)
    draw_eye(unit)
    fly_turn(270,2*unit,0,0,0) #(3,25/4)
    draw_eye(-unit)
# return to origin
    fly_turn(0,3*unit,270,25*unit/4,270) #(0,0)

def draw_letter_b(unit):
    width(1)
# outline of B
    fly_turn(0,unit,270,3*unit/4,0) #(1,1/4)
    draw_segment(0,21*unit/4,-2*unit,90, 0,2*unit,-2*unit,180,0,0) #(5,4)
    draw_segment(180,0,-2*unit,150, 300,(((7-4*sqrt(3)))/4)*unit,0,0,0,0) #(6,1/4)
    draw_master_ghostyskirt(unit,4) #(3/2,1/4)
    draw_segment(0,0,unit/4,90, 0,0,-unit/4,90,0,0) #(1,3/4)
# face of B
    fly_turn(0,4*unit,90,3.5*unit,0)
    draw_segment(0,0,unit,180,0,unit,unit,180, 0,unit)
    fly_turn(90,3.5*unit,270,0,0)
    draw_segment(0,0,unit,180,0,unit,unit,180, 0,unit) #(9/2,5/4)
    fly_turn(270,11*unit/2,90,unit,270)
    draw_eye(unit) #(5.5,6.75)
    fly_turn(270,3*unit,0,0,0)
    draw_eye(-unit) #(2.5,6.75)
# return to origin
    fly_turn(0,2.5*unit,270,6.75*unit,270)

def draw_letter_c(unit):
    width(1)
# outline of C
    fly_turn(0,unit,270,unit,0)
    draw_segment(0,4*unit,-3*unit,90, 0,2*unit,-unit,180,0,0)
    draw_segment(0,2*unit,unit,90,0,7*unit/4,unit,90,0,2*unit)
    draw_segment(0,0,-unit,180, 270,0,0,0,0,0)
    draw_master_ghostyskirt(unit,4)
    draw_segment(0,0,unit/4,90,0,0,-unit/4,90,0,unit/4)
# face of C
    fly_turn(0,5.5*unit,90,3*unit,270)
    draw_eye(unit)
# return to origin
    fly_turn(270,4*unit,270,6.5*unit,270)

def draw_letter_d(unit):
    width(1)
# outline of D
    fly_turn(0,unit,270,unit,0)
    draw_segment(0,6*unit,-unit,90,0,3*unit,-2*unit,90,0,3.75*unit)
    draw_segment(0,0,-2*unit,90,270,0,0,0,0,0)
    draw_master_ghostyskirt(unit, 3)
    draw_segment(0,0,unit/4,90, 0,0,-unit/4,90,0,unit/4)
# face of D
    fly_turn(0,2.5*unit,90,2*unit,90)
    draw_segment(0,0,unit,180, 0,unit,unit,180,0,unit)
    fly_turn(180,2*unit,0,0,0)
    draw_eye(unit)
    fly_turn(90,2*unit,270,0,0)
    draw_eye(unit)
# return to origin
    fly_turn(270,5*unit,270,5.5*unit,270)

def draw_letter_e(unit):
    pass

def draw_letter_f(unit):
    pass

def draw_letter_g(unit):
    pass

def draw_letter_h(unit):
    pass

def draw_letter_i(unit):
    pass

def draw_letter_j(unit):
    pass

def draw_letter_k(unit):
    pass

def draw_letter_l(unit):
    pass

def draw_letter_m(unit):
    pass

def draw_letter_n(unit):
    pass

def draw_letter_o(unit):
    pass

def draw_letter_p(unit):
    pass

def draw_letter_q(unit):
    pass

def draw_letter_r(unit):
    pass

def draw_letter_s(unit):
    pass

def draw_letter_t(unit):
    pass

def draw_letter_u(unit):
    pass

def draw_letter_v(unit):
    pass

def draw_letter_w(unit):
    pass

def draw_letter_x(unit):
    pass

def draw_letter_y(unit):
    pass

def draw_letter_z(unit):
    pass
